W3cubDocs

/Deno 2

deno run, run a file

Command line usage:
deno run [OPTIONS] [SCRIPT_ARG]...

Run a JavaScript or TypeScript program, or a task or script.

By default all programs are run in sandbox without access to disk, network or ability to spawn subprocesses.

deno run https://examples.deno.land/hello-world.ts

Grant permission to read from disk and listen to network:

deno run --allow-read --allow-net jsr:@std/http/file-server

Grant permission to read allow-listed files from disk:

deno run --allow-read=/etc jsr:@std/http/file-server

Grant all permissions:

deno run -A jsr:@std/http/file-server

Specifying the filename '-' to read the file from stdin.

curl https://examples.deno.land/hello-world.ts | deno run -

Type checking options

--check

Enable type-checking. This subcommand does not type-check by default If the value of "all" is supplied, remote modules will be included. Alternatively, the 'deno check' subcommand can be used.

--no-check

Skip type-checking. If the value of "remote" is supplied, diagnostic errors from remote modules will be ignored.

Dependency management options

--cached-only

Require that remote dependencies are already cached.

--frozen

Error out if lockfile is out of date.

--import-map

Load import map file from local file or remote URL.

--lock

Check the specified lock file. (If value is not provided, defaults to "./deno.lock").

--no-lock

Disable auto discovery of the lock file.

--no-npm

Do not resolve npm modules.

--no-remote

Do not resolve remote modules.

--node-modules-dir

Sets the node modules management mode for npm packages.

--reload

Short flag: -r

Reload source code cache (recompile TypeScript) no value Reload everything jsr:@std/http/file-server,jsr:@std/assert/assert-equals Reloads specific modules npm: Reload all npm modules npm:chalk Reload specific npm module.

--vendor

Toggles local vendor folder usage for remote modules and a node_modules folder for npm packages.

Options

--allow-scripts

Allow running npm lifecycle scripts for the given packages Note: Scripts will only be executed when using a node_modules directory (--node-modules-dir).

--cert

Load certificate authority from PEM encoded file.

--conditions

Use this argument to specify custom conditions for npm package exports. You can also use DENO_CONDITIONS env var. .

--config

Short flag: -c

Configure different aspects of deno including TypeScript, linting, and code formatting. Typically the configuration file will be called deno.json or deno.jsonc and automatically detected; in that case this flag is not necessary.

--coverage

Collect coverage profile data into DIR. If DIR is not specified, it uses 'coverage/'. This option can also be set via the DENO_COVERAGE_DIR environment variable.

--env-file

Load environment variables from local file Only the first environment variable with a given key is used. Existing process environment variables are not overwritten, so if variables with the same names already exist in the environment, their values will be preserved. Where multiple declarations for the same environment variable exist in your .env file, the first one encountered is applied. This is determined by the order of the files you pass as arguments.

--ext

Set content type of the supplied file.

--location

Value of globalThis.location used by some web APIs.

--no-code-cache

Disable V8 code cache feature.

--no-config

Disable automatic loading of the configuration file.

--preload

A list of files that will be executed before the main module.

--seed

Set the random number generator seed.

--v8-flags

To see a list of all available flags use --v8-flags=--help Flags can also be set via the DENO_V8_FLAGS environment variable. Any flags set with this flag are appended after the DENO_V8_FLAGS environment variable.

Debugging options

--inspect

Activate inspector on host:port [default: 127.0.0.1:9229]

--inspect-brk

Activate inspector on host:port, wait for debugger to connect and break at the start of user script.

--inspect-wait

Activate inspector on host:port and wait for debugger to connect before running user code.

File watching options

--no-clear-screen

Do not clear terminal screen when under watch mode.

--watch

Watch for file changes and restart process automatically. Local files from entry point module graph are watched by default. Additional paths might be watched by passing them as arguments to this flag.

--watch-exclude

Exclude provided files/patterns from watch mode.

--watch-hmr

Watch for file changes and restart process automatically. Local files from entry point module graph are watched by default. Additional paths might be watched by passing them as arguments to this flag.

Usage

To run this file use:

deno run https://docs.deno.com/examples/scripts/hello_world.ts

You can also run files locally. Ensure that you are in the correct directory and use:

deno run hello-world.ts

By default, Deno runs programs in a sandbox without access to disk, network or ability to spawn subprocesses. This is because the Deno runtime is secure by default. You can grant or deny required permissions using the --allow-* and --deny-* flags.

Permissions examples

Grant permission to read from disk and listen to network:

deno run --allow-read --allow-net server.ts

Grant permission to read allow-listed files from disk:

deno run --allow-read=/etc server.ts

Grant all permissions this is not recommended and should only be used for testing:

deno run -A server.ts

If your project requires multiple security flags you should consider using a deno task to execute them.

Watch

To watch for file changes and restart process automatically use the --watch flag. Deno's built in application watcher will restart your application as soon as files are changed.

Be sure to put the flag before the file name eg:

deno run --allow-net --watch server.ts

Deno's watcher will notify you of changes in the console, and will warn in the console if there are errors while you work.

Running a package.json script

package.json scripts can be executed with the deno task command.

Running code from stdin

You can pipe code from stdin and run it immediately with:

curl https://docs.deno.com/examples/scripts/hello_world.ts | deno run -

Terminate run

To stop the run command use ctrl + c.

© 2018–2025 the Deno authors
Licensed under the MIT License.
https://docs.deno.com/runtime/reference/cli/run